/* tslint:disable */
import { Injectable } from '@angular/core';
import { HttpClient, HttpRequest, HttpResponse, HttpHeaders } from '@angular/common/http';
import { BaseService as __BaseService } from '../base-service';
import { OmsConfiguration as __Configuration } from '../oms-configuration';
import { StrictHttpResponse as __StrictHttpResponse } from '../strict-http-response';
import { Observable as __Observable } from 'rxjs';
import { map as __map, filter as __filter } from 'rxjs/operators';

import { ListResponseArgsOfOrderItemListItemDTO } from '../models/list-response-args-of-order-item-list-item-dto';
import { QueryTokenDTO } from '../models/query-token-dto';
import { ResponseArgsOfIEnumerableOfInputDTO } from '../models/response-args-of-ienumerable-of-input-dto';
import { ResponseArgsOfIEnumerableOfAutocompleteDTO } from '../models/response-args-of-ienumerable-of-autocomplete-dto';
import { AutocompleteTokenDTO } from '../models/autocomplete-token-dto';
@Injectable({
  providedIn: 'root',
})
class AbholfachService extends __BaseService {
  static readonly AbholfachWareneingangsuchePath = '/wareneingang/s';
  static readonly AbholfachWareneingangOffenePostenMeldenummerPath = '/wareneingang/offeneposten/meldenummer';
  static readonly AbholfachWareneingangOffenePostenInStockPath = '/wareneingang/offeneposten/instock';
  static readonly AbholfachWareneingangOffenePostenOutOfStockPath = '/wareneingang/offeneposten/outofstock';
  static readonly AbholfachGetWarenausgabeFilterPath = '/warenausgabe/filter';
  static readonly AbholfachWarenausgabeAutocompletePath = '/warenausgabe/s/complete';
  static readonly AbholfachWarenausgabePath = '/warenausgabe/s';
  static readonly AbholfachAbholfachbereinigungPath = '/abholfach/abholfachbereinigung';

  constructor(
    config: __Configuration,
    http: HttpClient
  ) {
    super(config, http);
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangsucheResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/wareneingang/s`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangsuche(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachWareneingangsucheResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenMeldenummerResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/wareneingang/offeneposten/meldenummer`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenMeldenummer(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachWareneingangOffenePostenMeldenummerResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenInStockResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/wareneingang/offeneposten/instock`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenInStock(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachWareneingangOffenePostenInStockResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenOutOfStockResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/wareneingang/offeneposten/outofstock`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWareneingangOffenePostenOutOfStock(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachWareneingangOffenePostenOutOfStockResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }
  AbholfachGetWarenausgabeFilterResponse(): __Observable<__StrictHttpResponse<ResponseArgsOfIEnumerableOfInputDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    let req = new HttpRequest<any>(
      'GET',
      this.rootUrl + `/warenausgabe/filter`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ResponseArgsOfIEnumerableOfInputDTO>;
      })
    );
  }  AbholfachGetWarenausgabeFilter(): __Observable<ResponseArgsOfIEnumerableOfInputDTO> {
    return this.AbholfachGetWarenausgabeFilterResponse().pipe(
      __map(_r => _r.body as ResponseArgsOfIEnumerableOfInputDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWarenausgabeAutocompleteResponse(payload: AutocompleteTokenDTO): __Observable<__StrictHttpResponse<ResponseArgsOfIEnumerableOfAutocompleteDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/warenausgabe/s/complete`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ResponseArgsOfIEnumerableOfAutocompleteDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWarenausgabeAutocomplete(payload: AutocompleteTokenDTO): __Observable<ResponseArgsOfIEnumerableOfAutocompleteDTO> {
    return this.AbholfachWarenausgabeAutocompleteResponse(payload).pipe(
      __map(_r => _r.body as ResponseArgsOfIEnumerableOfAutocompleteDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachWarenausgabeResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/warenausgabe/s`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachWarenausgabe(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachWarenausgabeResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }

  /**
   * @param payload Suchkriterien
   */
  AbholfachAbholfachbereinigungResponse(payload: QueryTokenDTO): __Observable<__StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = payload;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/abholfach/abholfachbereinigung`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ListResponseArgsOfOrderItemListItemDTO>;
      })
    );
  }
  /**
   * @param payload Suchkriterien
   */
  AbholfachAbholfachbereinigung(payload: QueryTokenDTO): __Observable<ListResponseArgsOfOrderItemListItemDTO> {
    return this.AbholfachAbholfachbereinigungResponse(payload).pipe(
      __map(_r => _r.body as ListResponseArgsOfOrderItemListItemDTO)
    );
  }
}

module AbholfachService {
}

export { AbholfachService }
